''----------------------------------------------------------------------''                                                                                                       ''
''                                                                      ''
''                BLUE VEHICLE BY PETER507 2010                        ''
''               gg: 6135947 mail: peter507@o2.pl                       ''
''                                                                      ''
''                                                                      ''
''----------------------------------------------------------------------''                                                                                                       ''
''----------------------------------------------------------------------''

$regfile = "m8def.dat"
$crystal = 8000000
$baud = 19200

Enable Interrupts



'-------konfiguracja timera do generowania sygnau PWM warunkujcego prdko pojazdu
Config Timer0 = Timer , Prescale = 256
On Timer0 Napiecie

Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down , Prescale = 1


Config Adc = Single , Prescaler = Auto , Reference = Internal

Enable Timer0
Enable Timer1


Dim Odbior As Byte , Wart_ac As Word , Speed1 As Byte
Dim Wart_nap As String * 3 , V As Single , Speed As Byte , Test As Bit
Dim Test1 As Byte , Sprkier As Byte


Config Pind.3 = 1 : Portd.3 = 0
Config Pind.4 = 1 : Portd.4 = 0                             'konfiguracja portw do sterowania L293D
Config Pind.5 = 1 : Portd.5 = 0
Config Pind.6 = 1 : Portd.6 = 0

Config Pinc.5 = 1 : Portc.5 = 0                             'konfiguracja portu sterowania przekanikiem
Config Pinc.4 = 0 : Portc.4 = 1                             'konfiguracja portu przycisku


Declare Sub Przod
Declare Sub Tyl                                             'deklaracja podprogramw wykonujcych ruchy pojazdu
Declare Sub Prawa
Declare Sub Lewa
Declare Sub Ustawienia

Odbior = 0                                                  'zerowanie zmiennych
Test = 0
Test1 = 0
Sprkier = 0

Do



   Odbior = Inkey()


   Select Case Odbior

      Case 52 : Portc.5 = 1                                 'wczenie przekanika

      Case 53 : Portc.5 = 0                                 'wyczenie przekanika

      Case 97 : Call Tyl

      Case 98 : Pwm1a = 0
                Pwm1b = 0                                   'procedura zatrzymania pojazdu
                Sprkier = 6

      Case 99 : Call Przod

      Case 100 : Call Prawa

      Case 101 : Call Lewa

   End Select


      If Odbior = 49 Then
         Speed = 100                                        'wartoci wypenienia PWM dobieramy do silnikw jakie napdzamy
         Speed1 = 90

         Select Case Sprkier
            Case 1 : Pwm1b = Speed
                      Pwm1a = Speed
            Case 2 : Pwm1b = Speed1
                      Pwm1a = Speed
            Case 3 : Pwm1b = Speed
                     Pwm1a = Speed1
            Case 4 : Pwm1b = Speed
                     Pwm1a = Speed1
            Case 5 : Pwm1b = Speed1
                     Pwm1a = Speed
            Case 6 : Pwm1a = 0
                     Pwm1b = 0
         End Select

      End If

      If Odbior = 50 Then
         Speed = 130                                        'wartoci wypenienia PWM dobieramy do silnikw jakie napdzamy
         Speed1 = 90

          Select Case Sprkier
            Case 1 : Pwm1b = Speed
                      Pwm1a = Speed
            Case 2 : Pwm1b = Speed1
                      Pwm1a = Speed
            Case 3 : Pwm1b = Speed
                     Pwm1a = Speed1
            Case 4 : Pwm1b = Speed
                     Pwm1a = Speed1
            Case 5 : Pwm1b = Speed1
                     Pwm1a = Speed
            Case 6 : Pwm1a = 0
                     Pwm1b = 0
         End Select

      End If

     If Odbior = 51 Then
         Speed = 150                                        'wartoci wypenienia PWM dobieramy do silnikw jakie napdzamy
         Speed1 = 90

        Select Case Sprkier
            Case 1 : Pwm1b = Speed
                      Pwm1a = Speed
            Case 2 : Pwm1b = Speed1
                      Pwm1a = Speed
            Case 3 : Pwm1b = Speed
                     Pwm1a = Speed1
            Case 4 : Pwm1b = Speed
                     Pwm1a = Speed1
            Case 5 : Pwm1b = Speed1
                     Pwm1a = Speed
            Case 6 : Pwm1a = 0
                     Pwm1b = 0
         End Select

     End If


   Odbior = 0


   If Pinc.4 = 0 Then
      Wait 1
      If Pinc.4 = 0 Then                                    'procedura pierwszej konfiguracji ukadu BTM-222
         Call Ustawienia
      End If
   End If

Loop
End


Sub Tyl

   Pwm1b = Speed
   Pwm1a = Speed                                            'procedura jazdy do przodu

   Reset Portd.4
   Set Portd.3

   Set Portd.6
   Reset Portd.5
   Test = 0
   Sprkier = 1

End Sub

'------------------

Sub Przod

   Pwm1b = Speed
   Pwm1a = Speed                                            'procedura jazdy do tyu

   Set Portd.4
   Reset Portd.3

   Set Portd.5
   Reset Portd.6
   Test = 1
   Sprkier = 1

End Sub

'-----------------

Sub Prawa                                                   'procedura jazdy w praw

    If Test = 1 Then

      Pwm1b = Speed1
      Pwm1a = Speed

      Set Portd.4
      Reset Portd.3

      Set Portd.5
      Reset Portd.6

      Sprkier = 2


   Else

      Pwm1b = Speed
      Pwm1a = Speed1

      Reset Portd.4
      Set Portd.3

      Set Portd.6
      Reset Portd.5

      Sprkier = 3

   End If


End Sub



'-----------------

Sub Lewa                                                    'procedura jazdy w lew


   If Test = 1 Then

      Pwm1b = Speed
      Pwm1a = Speed1

      Set Portd.4
      Reset Portd.3

      Set Portd.5
      Reset Portd.6

      Sprkier = 4


   Else

      Pwm1b = Speed1
      Pwm1a = Speed

      Reset Portd.4
      Set Portd.3

      Set Portd.6
      Reset Portd.5

      Sprkier = 5

   End If


End Sub

'------------------

Napiecie:
                                                   'procedura wysyania napicia akumulatora
   Incr Test1

   If Test1 = 255 Then

      Start Adc
         Wart_ac = Getadc(0)                                'odczytanie wartoci z wejcia
         V = Wart_ac * 0.0025
         V = V * 10                                         'zamiana odczytanej wartoci
         Wart_nap = Fusing(v , "#.&")
         Wart_nap = Wart_nap + "V"
         Print Wart_nap
         Test1 = 0
      Stop Adc

   End If


Return

'---------------

Sub Ustawienia:                                             'nadanie nazwy moduowi BTM

Print "A"
Waitms 200
Print "T"
Waitms 200
Print
Waitms 200
Print "A"
Waitms 100
Print "T"
Waitms 100
Print "N"
Waitms 100
Print "="                                                   '
Waitms 100
Print "R"
Waitms 100
Print "o"
Waitms 100
Print "b"
Waitms 100
Print "o"
Waitms 100
Print "t"
Waitms 100
Print
Waitms 10

End Sub